diff -r 98a16ccdf418 trytond/modules/production/bom.py
--- a/trytond/modules/production/bom.py	Mon Sep 10 15:28:23 2012 +0200
+++ b/trytond/modules/production/bom.py	Mon Sep 24 20:36:41 2012 +0200
@@ -7,10 +7,13 @@
 from trytond.pool import Pool
 
 
+__all__ = ['BOM', 'BOMInput', 'BOMOutput', 'BOMTree', 'OpenBOMTreeStart',
+    'OpenBOMTreeTree', 'OpenBOMTree']
+
+
 class BOM(ModelSQL, ModelView):
     "Bill of Material"
-    _name = 'production.bom'
-    _description = __doc__
+    __name__ = 'production.bom'
 
     name = fields.Char('Name', required=True, translate=True)
     active = fields.Boolean('Active', select=1)
@@ -19,35 +22,34 @@
     output_products = fields.Many2Many('production.bom.output',
         'bom', 'product', 'Output Products')
 
-    def default_active(self):
+    @staticmethod
+    def default_active():
         return True
 
-    def compute_factor(self, bom, product, quantity, uom):
+    def compute_factor(self, product, quantity, uom):
         '''
         Compute factor for an output product
         '''
-        uom_obj = Pool().get('product.uom')
-        for output in bom.outputs:
+        Uom = Pool().get('product.uom')
+        for output in self.outputs:
             if output.product == product:
-                quantity = uom_obj.compute_qty(uom, quantity,
+                quantity = Uom.compute_qty(uom, quantity,
                     output.uom, round=False)
                 return quantity / output.quantity
 
-    def copy(self, ids, default=None):
+    @classmethod
+    def copy(cls, records, default=None):
         if default is None:
             default = {}
         else:
             default = default.copy()
         default['output_products'] = False
-        return super(BOM, self).copy(ids, default=default)
-
-BOM()
+        return super(BOM, cls).copy(records, default=default)
 
 
 class BOMInput(ModelSQL, ModelView):
     "Bill of Material Input"
-    _name = 'production.bom.input'
-    _description = __doc__
+    __name__ = 'production.bom.input'
     _rec_name = 'product'
 
     bom = fields.Many2One('production.bom', 'BOM', required=True,
@@ -58,104 +60,75 @@
         ], on_change=['product', 'uom'])
     uom_category = fields.Function(fields.Many2One(
         'product.uom.category', 'Uom Category',
-        on_change_with=['product']), 'get_uom_category')
+        on_change_with=['product']), 'on_change_with_uom_category')
     uom = fields.Many2One('product.uom', 'Uom', required=True,
         domain=[
             ('category', '=', Eval('uom_category')),
         ], depends=['uom_category'])
     unit_digits = fields.Function(fields.Integer('Unit Digits',
-        on_change_with=['uom']), 'get_unit_digits')
+        on_change_with=['uom']), 'on_change_with_unit_digits')
     quantity = fields.Float('Quantity', required=True,
         digits=(16, Eval('unit_digits', 2)),
         depends=['unit_digits'])
 
-    def __init__(self):
-        super(BOMInput, self).__init__()
-        self._sql_constraints = [
+    @classmethod
+    def __setup__(cls):
+        super(BOMInput, cls).__setup__()
+        cls._sql_constraints = [
             ('product_bom_uniq', 'UNIQUE(product, bom)',
                 'product_bom_uniq'),
-        ]
-        self._constraints += [
+            ]
+        cls._constraints += [
             ('check_bom_recursion', 'recursive_bom'),
-        ]
-        self._error_messages.update({
-            'product_bom_uniq': 'Product must be unique per BOM!',
-            'recursive_bom': 'You can not create recursive BOMs!',
-        })
+            ]
+        cls._error_messages.update({
+                'product_bom_uniq': 'Product must be unique per BOM!',
+                'recursive_bom': 'You can not create recursive BOMs!',
+                })
 
-    def on_change_product(self, vals):
-        product_obj = Pool().get('product.product')
-
+    def on_change_product(self):
         res = {}
-        if vals.get('product'):
-            product = product_obj.browse(vals['product'])
-            uom_ids = [x.id for x in product.default_uom.category.uoms]
-            if (not vals.get('uom')
-                    or vals.get('uom') not in uom_ids):
-                res['uom'] = product.default_uom.id
-                res['uom.rec_name'] = product.default_uom.rec_name
-                res['unit_digits'] = product.default_uom.digits
+        if self.product:
+            uoms = self.product.default_uom.category.uoms
+            if (not self.uom or self.uom not in uoms):
+                res['uom'] = self.product.default_uom.id
+                res['uom.rec_name'] = self.product.default_uom.rec_name
+                res['unit_digits'] = self.product.default_uom.digits
         else:
-            res['uom'] = False
+            res['uom'] = None
             res['uom.rec_name'] = ''
             res['unit_digits'] = 2
         return res
 
-    def on_change_with_uom_category(self, vals):
-        product_obj = Pool().get('product.product')
-        if vals.get('product'):
-            product = product_obj.browse(vals['product'])
-            return product.default_uom.category.id
-        return False
+    def on_change_with_uom_category(self, name=None):
+        if self.product:
+            return self.product.default_uom.category.id
 
-    def get_uom_category(self, ids, name):
-        res = {}
-        for input in self.browse(ids):
-            res[input.id] = input.product.default_uom.category.id
-        return res
-
-    def on_change_with_unit_digits(self, vals):
-        uom_obj = Pool().get('product.uom')
-        if vals.get('uom'):
-            uom = uom_obj.browse(vals['uom'])
-            return uom.digits
+    def on_change_with_unit_digits(self, name=None):
+        if self.uom:
+            return self.uom.digits
         return 2
 
-    def get_unit_digits(self, ids, name):
-        res = {}
-        for input in self.browse(ids):
-            res[input.id] = input.uom.digits
-        return res
-
-    def check_bom_recursion(self, ids):
+    def check_bom_recursion(self):
         '''
         Check BOM recursion
         '''
-        product_obj = Pool().get('product.product')
+        return self.product.check_bom_recursion()
 
-        inputs = self.browse(ids)
-        product_ids = [input.product.id for input in inputs]
-        return product_obj.check_bom_recursion(product_ids)
-
-    def compute_quantity(self, line, factor):
-        uom_obj = Pool().get('product.uom')
-        return uom_obj.round(line.quantity * factor, line.uom.rounding)
-
-BOMInput()
+    def compute_quantity(self, factor):
+        Uom = Pool().get('product.uom')
+        return Uom.round(self.quantity * factor, self.uom.rounding)
 
 
 class BOMOutput(BOMInput):
     "Bill of Material Output"
-    _name = 'production.bom.output'
-    _description = __doc__
-
-BOMOutput()
+    __name__ = 'production.bom.output'
+    _table = 'production_bom_output'  # Needed to override BOMInput._table
 
 
 class BOMTree(ModelView):
     'BOM Tree'
-    _name = 'production.bom.tree'
-    _description = __doc__
+    __name__ = 'production.bom.tree'
 
     product = fields.Many2One('product.product', 'Product')
     quantity = fields.Float('Quantity', digits=(16, Eval('unit_digits', 2)),
@@ -164,9 +137,9 @@
     unit_digits = fields.Integer('Unit Digits')
     childs = fields.One2Many('production.bom.tree', None, 'Childs')
 
-    def tree(self, product, quantity, uom, bom=None):
-        bom_obj = Pool().get('production.bom')
-        input_obj = Pool().get('production.bom.input')
+    @classmethod
+    def tree(cls, product, quantity, uom, bom=None):
+        Input = Pool().get('production.bom.input')
 
         result = []
         if bom is None:
@@ -174,26 +147,24 @@
                 return result
             bom = product.boms[0].bom
 
-        factor = bom_obj.compute_factor(bom, product, quantity, uom)
-        for input in bom.inputs:
-            quantity = input_obj.compute_quantity(input, factor)
-            childs = self.tree(input.product, quantity, input.uom)
+        factor = bom.compute_factor(product, quantity, uom)
+        for input_ in bom.inputs:
+            quantity = Input.compute_quantity(input_, factor)
+            childs = cls.tree(input_.product, quantity, input_.uom)
             values = {
-                'product': input.product.id,
+                'product': input_.product.id,
                 'quantity': quantity,
-                'uom': input.uom.id,
-                'unit_digits': input.uom.digits,
+                'uom': input_.uom.id,
+                'unit_digits': input_.uom.digits,
                 'childs': childs,
             }
             result.append(values)
         return result
 
-BOMTree()
-
 
 class OpenBOMTreeStart(ModelView):
     'Open BOM Tree'
-    _name = 'production.bom.tree.open.start'
+    __name__ = 'production.bom.tree.open.start'
 
     quantity = fields.Float('Quantity', required=True,
         digits=(16, Eval('unit_digits', 2)), depends=['unit_digits'])
@@ -211,44 +182,39 @@
         ], depends=['product'])
     product = fields.Many2One('product.product', 'Product', readonly=True)
 
-    def on_change_with_unit_digits(self, values):
-        uom_obj = Pool().get('product.uom')
-        if values.get('uom'):
-            uom = uom_obj.browse(values['uom'])
-            return uom.digits
+    def on_change_with_unit_digits(self):
+        if self.uom:
+            return self.uom.digits
         return 2
 
-OpenBOMTreeStart()
-
 
 class OpenBOMTreeTree(ModelView):
     'Open BOM Tree'
-    _name = 'production.bom.tree.open.tree'
+    __name__ = 'production.bom.tree.open.tree'
 
     bom_tree = fields.One2Many('production.bom.tree', None, 'BOM Tree')
 
-    def tree(self, bom, product, quantity, uom):
+    @classmethod
+    def tree(cls, bom, product, quantity, uom):
         pool = Pool()
-        tree_obj = pool.get('production.bom.tree')
+        Tree = pool.get('production.bom.tree')
 
-        childs = tree_obj.tree(product, quantity, uom, bom=bom)
+        childs = Tree.tree(product, quantity, uom, bom=bom)
         bom_tree = [{
-            'product': product.id,
-            'quantity': quantity,
-            'uom': uom.id,
-            'unit_digits': uom.digits,
-            'childs': childs,
-        }]
+                'product': product.id,
+                'quantity': quantity,
+                'uom': uom.id,
+                'unit_digits': uom.digits,
+                'childs': childs,
+                }]
         return {
             'bom_tree': bom_tree,
-        }
-
-OpenBOMTreeTree()
+            }
 
 
 class OpenBOMTree(Wizard):
     'Open BOM Tree'
-    _name = 'production.bom.tree.open'
+    __name__ = 'production.bom.tree.open'
 
     start = StateView('production.bom.tree.open.start',
         'production.bom_tree_open_start_view_form', [
@@ -261,29 +227,27 @@
             Button('Close', 'end', 'tryton-close'),
             ])
 
-    def default_start(self, session, fields):
-        product_obj = Pool().get('product.product')
+    def default_start(self, fields):
+        Product = Pool().get('product.product')
         defaults = {}
-        product = product_obj.browse(Transaction().context['active_id'])
+        product = Product(Transaction().context['active_id'])
         defaults['category'] = product.default_uom.category.id
-        if session.start.uom:
-            defaults['uom'] = session.start.uom.id
-            defaults['unit_digits'] = session.start.unit_digits
+        if getattr(self.start, 'uom', None):
+            defaults['uom'] = self.start.uom.id
+            defaults['unit_digits'] = self.start.unit_digits
         else:
             defaults['uom'] = product.default_uom.id
             defaults['unit_digits'] = product.default_uom.digits
         defaults['product'] = product.id
-        if session.start.bom:
-            defaults['bom'] = session.start.bom.id
+        if getattr(self.start, 'bom', None):
+            defaults['bom'] = self.start.bom.id
         elif product.boms:
             defaults['bom'] = product.boms[0].id
-        defaults['quantity'] = session.start.quantity
+        defaults['quantity'] = getattr(self.start, 'quantity', None)
         return defaults
 
-    def default_tree(self, session, fields):
+    def default_tree(self, fields):
         pool = Pool()
-        bom_tree_obj = pool.get('production.bom.tree.open.tree')
-        return bom_tree_obj.tree(session.start.bom.bom, session.start.product,
-            session.start.quantity, session.start.uom)
-
-OpenBOMTree()
+        BomTree = pool.get('production.bom.tree.open.tree')
+        return BomTree.tree(self.start.bom.bom, self.start.product,
+            self.start.quantity, self.start.uom)
diff -r 98a16ccdf418 trytond/modules/production/configuration.py
--- a/trytond/modules/production/configuration.py	Mon Sep 10 15:28:23 2012 +0200
+++ b/trytond/modules/production/configuration.py	Mon Sep 24 20:36:41 2012 +0200
@@ -3,11 +3,12 @@
 from trytond.model import ModelView, ModelSQL, ModelSingleton, fields
 from trytond.pyson import Eval
 
+__all__ = ['Configuration']
+
 
 class Configuration(ModelSingleton, ModelSQL, ModelView):
     'Production Configuration'
-    _name = 'production.configuration'
-    _description = __doc__
+    __name__ = 'production.configuration'
 
     production_sequence = fields.Property(fields.Many2One('ir.sequence',
             'Production Sequence', domain=[
@@ -16,4 +17,3 @@
                 ('code', '=', 'production'),
                 ], required=True))
 
-Configuration()
diff -r 98a16ccdf418 trytond/modules/production/product.py
--- a/trytond/modules/production/product.py	Mon Sep 10 15:28:23 2012 +0200
+++ b/trytond/modules/production/product.py	Mon Sep 24 20:36:41 2012 +0200
@@ -2,10 +2,14 @@
 #this repository contains the full copyright notices and license terms.
 from trytond.model import ModelView, ModelSQL, fields
 from trytond.pyson import Eval, Get, If, Bool
+from trytond.pool import PoolMeta
 
+__all__ = ['Product', 'ProductBom']
+__metaclass__ = PoolMeta
 
-class Product(ModelSQL, ModelView):
-    _name = 'product.product'
+
+class Product:
+    __name__ = 'product.product'
 
     boms = fields.One2Many('product.product-production.bom', 'product',
         'BOMs', order=[('sequence', 'ASC'), ('id', 'ASC')],
@@ -14,39 +18,34 @@
             },
         depends=['type'])
 
-    def __init__(self):
-        super(Product, self).__init__()
-        self._constraints += [
+    @classmethod
+    def __setup__(cls):
+        super(Product, cls).__setup__()
+        cls._constraints += [
             ('check_bom_recursion', 'recursive_bom'),
-        ]
-        self._error_messages.update({
-            'recursive_bom': 'You can not create recursive BOMs!',
-        })
+            ]
+        cls._error_messages.update({
+                'recursive_bom': 'You can not create recursive BOMs!',
+                })
 
-    def check_bom_recursion(self, ids):
+    def check_bom_recursion(self, product=None):
         '''
         Check BOM recursion
         '''
-        def check(sub_product, product):
-            for product_bom in sub_product.boms:
-                for input in product_bom.bom.inputs:
-                    if input.product == product:
-                        return False
-                    if not check(input.product, product):
-                        return False
-            return True
-        for product in self.browse(ids):
-            if not check(product, product):
-                return False
+        if product is None:
+            product = self
+        for product_bom in self.boms:
+            for input_ in product_bom.bom.inputs:
+                if input_.product == product:
+                    return False
+                if not input_.product.check_bom_recursion(product=product):
+                    return False
         return True
 
-Product()
-
 
 class ProductBom(ModelSQL, ModelView):
     'Product - BOM'
-    _name = 'product.product-production.bom'
-    _description = __doc__
+    __name__ = 'product.product-production.bom'
 
     product = fields.Many2One('product.product', 'Product',
         ondelete='CASCADE', select=1, required=True,
@@ -61,17 +60,14 @@
             ], depends=['product'])
     sequence = fields.Integer('Sequence')
 
-    def __init__(self):
-        super(ProductBom, self).__init__()
-        self._order.insert(0, ('sequence', 'ASC'))
+    @classmethod
+    def __setup__(cls):
+        super(ProductBom, cls).__setup__()
+        cls._order.insert(0, ('sequence', 'ASC'))
 
-    def get_rec_name(self, ids, name):
-        result = {}
-        for product_bom in self.browse(ids):
-            result[product_bom.id] = product_bom.bom.rec_name
-        return result
+    def get_rec_name(self, name):
+        return self.bom.rec_name
 
-    def search_rec_name(self, name, clause):
+    @classmethod
+    def search_rec_name(cls, name, clause):
         return [('bom.rec_name',) + tuple(clause[1:])]
-
-ProductBom()
